﻿-----------------------------------------------------------------------------------------
--Debuffs Group Frame--------------------------------------------------------------------
-----------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local UnitDebuff = UnitDebuff
local UnitGUID = UnitGUID
local UnitName = UnitName
local UnitIsEnemy = UnitIsEnemy
local GetTime = GetTime
local IsAddOnLoaded = IsAddOnLoaded
local pairs = pairs
local unpack = unpack
local bit_band = bit.band
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY
local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL

function SN:SetupDB()
	F.debuffs = T:NewGroup(SN.data.profile.debuffs.width, "Debuff Frame", debuffs, M.media.draghandle)
	F.debuffs:SetSorting("label")

	if(IsAddOnLoaded("ElvUI")) then
		F.debuffs:SetSpacing(0, 3)
		F.debuffs:SetStartPoint(SN.data.profile.debuffs.grow)
		F.debuffs:SetPoint(unpack(SN.data.profile.frames.elvdebuffs))
	else
		F.debuffs:SetSpacing(0, 3)
		F.debuffs:SetStartPoint(SN.data.profile.debuffs.grow)
		F.debuffs:SetPoint(unpack(SN.data.profile.frames.debuffs))
	end
	if SN.data.profile.debuffs.iconmode then
		F.debuffs:SetIconMode(32 * SN.data.profile.debuffs.iconscale, "BOTTOM", 0, 0)
		F.debuffs:SetSpacing(SN.data.profile.debuffs.fontsize / 2, SN.data.profile.debuffs.fontsize + 3)
	end
	F.debuffs:SetScript("OnEvent", function(self, event, ...)
		SN:DebuffEvents(self, event, ...)
	end)
		
	--Register our events for the frame
	
	if not SN.data.profile.debuffs.enable then
		SN:DebuffDisable()
	else
		SN:DebuffEnable()
	end

end

function SN:DebuffEnable()
	if not F.debuffs:IsVisible() then
		F.debuffs:Show()
	end
	F.debuffs:RegisterEvent("UNIT_AURA")
	F.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.debuffs:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function SN:DebuffDisable()
	F.debuffs:UnregisterEvent("UNIT_AURA")
	F.debuffs:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.debuffs:UnregisterEvent("PLAYER_TARGET_CHANGED")
	F.debuffs:Hide()
end

function SN:DebuffEvents(self, event, ...)

	--if event == "COMBAT_LOG_EVENT_UNFILTERED" then
	--	local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName, destFlags = ...
	--	local spellId, spellName = select(12, ...)
		
	--	if bit_band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 or
	--					(bit_band(destFlags, COMBATLOG_OBJECT_REACTION_NEUTRAL) > 0 and UnitIsEnemy("player", "target") == nil) then
	--		local bars = self.bars
	--		if self.bars then
	--			for i in pairs(bars) do 
	--				if i:GetData("SN:arg4") == sourceName then
	--					i:Stop()
	--				end
	--			end
	--		end
	--	end
	--end
	if event == "UNIT_AURA" then
		local unit = ...
			
		if unit == "target" then
			local i = 1
			while true do
				local name, _, _, _, _, dur, expirationTime, sourceName, _, _, spellId, canApplyAura = UnitDebuff("target", i)
				if not name then break end
				local bars = self.bars
				--Is there a bar for this debuff already?
				if sourceName =="player" then
					local dbf = self:Find("SN:arg5", name)
					if dbf ~= nil and expirationTime ~= nil then
						--SN:CreateBar(self, spellId, (expirationTime - GetTime()), UnitName(sourceName), UnitGUID("target"), name)
						if dbf:GetData("SN:arg2") == spellId and dbf:GetData("SN:arg3") == UnitGUID("target") then
							dbf:SetDuration((expirationTime - GetTime()), dur)
							dbf:Start()
						end
					elseif dbf == nil and expirationTime ~= nil then
						SN:CreateBar(self, spellId, (expirationTime - GetTime()), UnitName(sourceName), UnitGUID("target"), 
							name, SN.data.profile.debuffs.width, SN.data.profile.debuffs.height, SN.data.profile.debuffs.fontsize, LSM:Fetch("font", SN.data.profile.debuffs.font),
									LSM:Fetch("statusbar", SN.data.profile.debuffs.texture))

						for i in pairs(bars) do
							if i:GetData("SN:arg2") == spellId and i:GetData("SN:arg3") == UnitGUID("target") then
								i:SetDuration((expirationTime - GetTime()), dur)
								i:Start()
							end
						end
					end
				end
				i = i + 1
			end
		end
	end
	if event == "PLAYER_TARGET_CHANGED" then
		local bars = self.bars
		if self.bars then
			for i in pairs(bars) do
				if i:GetData("SN:arg3") ~= UnitGUID("target") then
					--SN:Debug("I should be stopped")
					i:Stop()
				end
			end
		end
		local i = 1
		while true do
			local name, _, _, _, _, dur, expirationTime, sourceName, _, _, spellId, canApplyAura = UnitDebuff("target", i)
			--Is there a bar for this debuff already?
			if not name then break end

			if sourceName =="player" then
				local dbf = self:Find("SN:arg5", name)
				if dbf == nil and expirationTime ~= nil then
					SN:CreateBar(self, spellId, (expirationTime - GetTime()), UnitName(sourceName), UnitGUID("target"), name,
						SN.data.profile.debuffs.width, SN.data.profile.debuffs.height, SN.data.profile.debuffs.fontsize, LSM:Fetch("font", SN.data.profile.debuffs.font),
								LSM:Fetch("statusbar", SN.data.profile.debuffs.texture))

					for i in pairs(bars) do
						if i:GetData("SN:arg2") == spellId and i:GetData("SN:arg3") == UnitGUID("target") then
							i:SetDuration((expirationTime - GetTime()), dur)
							i:Start()
						end
					end
				end
			end
			i = i + 1
		end
	end
end